unit Unit4;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Layers3D, FMX.Types3D,
  FMX.Objects3D, FMX.Objects, FMX.Ani, FMX.Effects, FMX.ExtCtrls, FMX.Layouts,
  FMX.Memo, FMX.Colors, FMX.Grid, Datasnap.Provider, Data.DB, Datasnap.DBClient,
  Xmlxform, Data.Bind.EngExt, Fmx.Bind.DBEngExt, Fmx.Bind.Editors, System.Rtti,
  System.Bindings.Outputs, Data.Bind.Components, Data.Bind.DBScope,
  Data.Bind.DBLinks, Fmx.Bind.DBLinks, FMX.Edit;

type
  TForm4 = class(TForm)
    Path1: TPath;
    OpenDialog1: TOpenDialog;
    Viewport3D1: TViewport3D;
    Layer3D1: TLayer3D;
    FloatAnimation1: TFloatAnimation;
    CheckBox1: TCheckBox;
    FloatAnimation2: TFloatAnimation;
    FloatAnimation3: TFloatAnimation;
    Button4: TButton;
    StyleBook1: TStyleBook;
    tbEscala: TTrackBar;
    lblScala: TLabel;
    tbColor: THueTrackBar;
    lblColor: TLabel;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    lblhttp: TLabel;
    Rectangle1: TRectangle;
    FloatAnimation4: TFloatAnimation;
    StringGrid1: TStringGrid;
    Grid3D1: TGrid3D;
    chkVerDatos: TCheckBox;
    _ClientDataSet1: TClientDataSet;
    DataSource2: TDataSource;
    cdslat: TFloatField;
    cdslon: TFloatField;
    cdsele: TFloatField;
    cdstime: TStringField;
    Panel3: TPanel;
    ProgressBar1: TProgressBar;
    lblNumPuntos: TLabel;
    BindingsList1: TBindingsList;
    BindScopeDB1: TBindScopeDB;
    DBLinkStringGrid11: TBindDBGridLink;
    BindDBGridLink1: TBindDBGridLink;
    chkVerData: TCheckBox;
    mmData: TMemo;
    SpinBox1: TSpinBox;
    Label2: TLabel;
    btnSalir: TButton;
    procedure CheckBox1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure tbEscalaChange(Sender: TObject);
    procedure tbColorChange(Sender: TObject);
    procedure lblhttpClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Path1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Single);
    procedure chkVerDatosChange(Sender: TObject);
    procedure chkVerDataChange(Sender: TObject);
    procedure SpinBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
  private
    TrackFile:String;      // Fichero de traack
    numPoints:Integer;      // Numero de puntos ldos

    procedure _ExtractPoints(AStr:String; var ALat, ALon:string);
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.fmx}

uses
  VCL.Dialogs, ShellAPI, Math, StrUtils;


procedure TForm4.btnSalirClick(Sender: TObject);
var
  p1,p2:TPointF;
begin

  p1.X := 0;     p1.Y :=0;
  p2 := path1.LocalToAbsolute(p1);
  p2 := path1.AbsoluteToLocal(p1);

  // Cerrar
  Self.Close;
end;

procedure TForm4.Button4Click(Sender: TObject);
var
  b:boolean;
  TS:TStringList;
  Str1, Str2, StrPath:String;
  I:integer;
  _lat, _lon:string;
  tmp1, tmp3:string;
  k,j,m:integer;
begin

  // limpiar previos
  if (_ClientDataSet1.Active) then begin
 //   _ClientDataSet1.ClearFields;
    _ClientDataSet1.Close;
  end;
  StringGrid1.RowCount := 1;
  Path1.Data.Data := '';
  numPoints := 0;
  TrackFile := '';
  ProgressBar1.Value := 0;
  lblNumPuntos.Text := '...';
  mmData.Lines.Text := '';
  //

  // Dilogo
  OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0)) + '\Samples\';
  b := OpenDialog1.Execute;

  // Seleccionada?
  if not(b)  then begin
    Exit;
  end;

  // Existe?
  if not FileExists(OpenDialog1.FileName) then begin
    Exit;
  end;

  // Inicializar
  TS := TStringList.Create();
  numPoints := 0;
  _ClientDataSet1.DisableControls;
  // componentes
  chkVerDatos.Enabled := True;
  chkVerData.Enabled := True;

  try

    // Cargar el fichero
    TS.LoadFromFile(OpenDialog1.FileName);
    i := 0;
    tmp1 := TS.Text;

    // Recorrido por todos los puntos
    while (i <= (TS.Count - 1)) do begin
      // Es un TXT?
      if (Uppercase(ExtractFileExt(OpenDialog1.FileName)) = '.TXT') then begin
        Str1 := TS.Names[i];
        Str2 := TS.ValueFromIndex[i];

        // Primero?
        if (i = 0) then begin
          StrPath := 'M' + Str1 + ',' + Str2;
        end
        else begin
          StrPath := StrPath + 'L' + Str1 + ',' + Str2;
        end;
         i := i + 1;
         numPoints := numPoints + 1;
      end
      else begin
        // Cargar...
        // tmp1 :=
        k := AnsiPos('<trkpt ', tmp1);
        if (k = 0) then begin
          i := TS.Count;   // Acabamos
        end
        else begin
          j := AnsiPos('</trkpt>', tmp1);
          tmp3 := Copy(tmp1, k, (j-k+Length('</trkpt>')));
          tmp1 := Copy(tmp1, j + Length('</trkpt>'), Length(tmp1));

          // extraer puntos y aadirlos al ClientDataset
          _ExtractPoints(tmp3, _lon, _lat);

          // Inicial?
          if (numPoints = 0) then begin
            StrPath := 'M' + _lat + ',' + _lon;
          end
          else begin
            StrPath := StrPath + 'L' + _lat + ',' + _lon;
          end;

          // Incrementat
          numPoints := numPoints + 1;

          if ((numPoints mod 25) = 0) then begin
            //_Memo1.Lines.Add(IntToStr(numPoints));
            m := Trunc(ProgressBar1.Value) + 5;
            m := m MOD Trunc(ProgressBar1.Max);
            ProgressBar1.Value := m;
            ProgressBar1.Repaint;
            Application.ProcessMessages;
          end;

        end;


      end;
    end;

    // Final del recorrido
    ProgressBar1.Value := ProgressBar1.Max;
    StringGrid1.RowCount := numPoints;
    lblNumPuntos.Text := IntToStr(numPoints) + ' puntos.';

    // Crear el Path
    Path1.Data.Data := StrPath;

  finally
    try
      _ClientDataSet1.EnableControls;
    except
      on E:EObserverException do begin
        // NADA
      end;
      on E:Exception do begin
        VCL.Dialogs.MessageDlg(Format('Message: %s'+#13+#10+'ClassName: %s',
          [E.Message, E.ClassName]), mtError, [mbOK], 0);
      end;
    end;
    FreeAndNil(TS);
  end;


end;

procedure TForm4.CheckBox1Change(Sender: TObject);
begin

  // arrancamos la animacin
  FloatAnimation1.Enabled := CheckBox1.IsChecked;
  FloatAnimation2.Enabled := CheckBox1.IsChecked;
  FloatAnimation3.Enabled := CheckBox1.IsChecked;

end;

procedure TForm4.chkVerDataChange(Sender: TObject);
begin

  // Hay algo?
  if (mmData.Lines.Text = '') then begin
    // Datos
    mmData.Lines.Text := Path1.Data.Data;
  end;
  mmData.Visible := chkVerData.IsChecked;
end;

procedure TForm4.chkVerDatosChange(Sender: TObject);
begin
  // Columnas
  StringGrid1.Columns[0].Width := 130;
  StringGrid1.Columns[1].Width := 130;
  StringGrid1.Columns[2].Width := 130;
  StringGrid1.Columns[3].Width := StringGrid1.Width - (130 * 3) - 20;

  // Sisible o no
  StringGrid1.Visible := chkVerDatos.IsChecked;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  // inicializar tamaos
  FormResize(nil);
end;

procedure TForm4.FormResize(Sender: TObject);
begin
  // redimensionar
//  Rectangle1.Height := Self.Height - 75;
  Self.Height := Max(Self.Height,  525);
  Self.Width := Max(Self.Width,  750);
  // StringG
  StringGrid1.Position.Y := Rectangle1.Position.Y;
  StringGrid1.Height := Rectangle1.Height;
  StringGrid1.Width := Self.Width - Rectangle1.Width - 30;
  // reajustar colunas
  chkVerDatosChange(nil);
  // memo
  mmData.Height := Rectangle1.Height + Rectangle1.Position.Y -
                   mmData.Position.Y - 45;
  btnSalir.Position.Y := Self.Height - 95;
end;

procedure TForm4.lblhttpClick(Sender: TObject);
begin
  FloatAnimation4.Enabled := False;
  FloatAnimation4.Enabled := True;
  ShellExecute(Handle, 'open', PWideChar(lblhttp.Text), nil, nil, 0);
end;

procedure TForm4.Path1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);
var
  pt, pf:TpointF;
begin
  //_Memo1.Lines.Add(Format('%f, %f',[X,Y]));
  pt.X := X;   pt.Y := Y;
  pf := Path1.AbsoluteToLocal(pt);
  pf := Path1.LocalToAbsolute(pt);
end;

procedure TForm4.SpinBox1Change(Sender: TObject);
begin
  Path1.StrokeThickness := SpinBox1.Value;
end;

procedure TForm4.tbColorChange(Sender: TObject);
begin

  // Color
  Path1.Stroke.Color := HSLtoRGB(tbColor.Value,0.9, 0.5);
end;

procedure TForm4.tbEscalaChange(Sender: TObject);
begin
  Layer3D1.Scale.X := tbEscala.Value;
  Layer3D1.Scale.Y := tbEscala.Value;
end;

procedure TForm4._ExtractPoints(AStr: String; var ALat, ALon:string);
var
  AResult:string;
  _lat, _lon, _ele, _time:string;
  ds:Char;

  // Permite parsear la cadena y extraer los datos.
  //
  function ExtractToken(Ini, Fin:String; StrIn:string; var StrResult:String):string;
  var
    i,j:integer;
    tmp2:string;
  begin
    i := AnsiPos(Ini, StrIn);
    if (i > 0) then begin
      i := i + Length(Ini);
      tmp2 := Copy(StrIn, i, Length(StrIn));
      StrResult := tmp2;
      j := AnsiPos(Fin, tmp2);
      if (j > 0) then begin
        Result := Copy(tmp2, 1, j - 1);
      end;
    end;
  end;
  //

begin

  // Datos de los diferentes puntos del Track
  _lat := ExtractToken('lat="', '"', AStr, AResult);
  ALat := _lat;
  _lon := ExtractToken('lon="', '"', AResult, AResult);
  ALon := _lon;
  _ele := ExtractToken('<ele>', '</ele>', AResult, AResult);
  _time := ExtractToken('<time>', '</time>', AResult, AResult);

  // Iniclamente estar cerrado.
  if (not _ClientDataSet1.Active) then begin
    _ClientDataSet1.CreateDataSet;
    _ClientDataSet1.Active := true;
  end;

  // Aadir los punots.
  ds := FormatSettings.DecimalSeparator;
  FormatSettings.DecimalSeparator := '.';
  try
    _ClientDataSet1.Append;
    cdslat.AsString := _lat;
    cdslon.AsString := _lon;
    cdsele.AsString := _ele;
    cdstime.AsString := _time;
    _ClientDataSet1.Post;
  finally
    FormatSettings.DecimalSeparator := ds;
  end;


end;

end.

